# DIY BME280 Sensor Shield for ESP8266

This is a DIY shield based on the [Bosch BME280](https://www.bosch-sensortec.com/bst/products/all_products/bme280) integrated environmental sensor. The shield is intended for use with the Wemos D1 Mini but can be adapted to any ESP8266-based device.

This shield is used to measure temperature & humidity readings in different rooms of a house and publish the readings to a MQTT broker. Apple HomeKit via [Homebridge](https://github.com/nfarina/homebridge) with a [MQTT plugin](https://github.com/arachnetech/homebridge-mqttthing), or any other MQTT client, subscribes to the corresponding MQTT topics and displays the readings.

This project takes inspiration and reuse for interfacing with the BME280 from [here](https://github.com/catdog2/mpy_bme280_esp8266), [here](https://obviate.io/2018/02/20/video-tutorial-bme820-environmental-sensor-and-mqtt-under-micropython/), and [here](https://randomnerdtutorials.com/low-power-weather-station-datalogger-using-esp8266-bme280-micropython/) but also includes enhancements such as use of a configuration file as well as extra exception handling. 

It is important to put the Wemos D1 Mini into a deep sleep mode to reduce current drain, especially for battery-based deployments, and to mitigate false readings caused by [self-heating](https://github.com/rwaldron/johnny-five/issues/1274#issuecomment-286586531) when running continuously.

## Parts List

Unit costs and suppliers listed below are current as of December 2018.

| Part | Unit Cost | Supplier |
| ---- | --------- | -------- |
| Wemos D1 Mini v3.0.0 | $3.83 | [eBay](https://www.ebay.com/usr/lovesell2013?_trksid=p2047675.l2559) |
| Wemos D1 Mini Protoboard | $0.75 | [eBay](https://www.ebay.com/usr/supper_star?_trksid=p2047675.l2559) |
| BME280 Breakout Board | $3.37 | [eBay](https://www.ebay.com/usr/cpthreego?_trksid=p2047675.l2559) |
| Wire Wrapping Wire | $6.54 | [eBay](https://www.ebay.com/usr/dm-goodss?_trksid=p2047675.l2559) |

## Wiring Diagram

Below is the wiring diagram for the DIY BME280 shield. The SparkFun BME280 breakout board shown is only for I2C wiring reference. Also note that `D0` and `RST` (reset) are shorted together in order for the Wemos D1 Mini to wake itself up from deep sleep mode via an interrupt. It is preferfable to short these two pins on the shield rather than on the pads provided on the Wemos D1 Mini itself. If this [issue](https://github.com/espressif/esptool/issues/277) is ever encountered, it is easier to remove the shield from the Wemos D1 Mini rather than removing the solder jumper between the pads.

![](./images/bme280-shield.png)

## bme280.py

This project makes use of the BME280 driver for micropython from this [repo](https://github.com/catdog2/mpy_bme280_esp8266). Clone the repo and write the `bme280.py` file to the root directory of the Wemos D1 Mini along with `boot.py`, `main.py`, and `config.json`.

## config.json

The current implementation of this project requires the `config.json` file to be in the root directory of the Wemos D1 Mini with `boot.py`, `main.py`, and `bme280.py`.

The format of the `config.json` file is as follows:

```
{
	"ssId": "<SSID of WLAN>",
	"key": "<Password / Network Key>",
	"mqttServer": "<FQDN or IP address of MQTT broker>",
	"mqttPort": <MQTT server port number>,
	"deviceId": "<device ID of MQTT client>"
}
```

An example `config.json` file may look like:

```
{
	"ssId": "my-wifi",
	"key": "0123456789ABCDEF",
	"mqttServer": "192.168.1.100",
	"mqttPort": 1883,
	"deviceId": "sensor-1"
}
```

## Exception Handling

This implementation handles 4 use-case exceptions:

1. The `config.json` file is missing
2. The `config.json` file exists, but a key-value pair is missing
3. The BME280 shield is not attached or there is a hardware communication failure
4. The MQTT broker is not reachable

If any of these use-cases were to occur, a serial terminal (e.g. linux or os x `screen` command) can capture the standard output error messages generated by the code.

Use-cases 1 and 2 will only occur due to misconfiguration of the application. Once fixed, both use-cases are unlikely to occur again. Use-case 1 can be tested by omitting the `config.json` file from the Wemos D1 Mini file system. Use-case 2 can be test by loading a `config.json` file into the Wemos D1 Mini but with one or more of the key-value pairs missing.

Use-case 3 may occur if for some reason the BME280 shield is not properly connected board-to-board with the Wemos D1 Mini. This situation can be tested by disconnecting the BME280 shield. The hardware communication failure aspect of this use-case is untested but is presumed to be no different from the BME280 shield being physically disconnected.

Use-case 4 may occur if for some reason the MQTT broker is offline. This can be tested by resetting / or shutting down a locally installed MQTT server. For a remote server, the LAN can be disconnected from the WAN to simulate an unreachable MQTT server; this aspect of the use-case is untested.

## BME280 Measurement Accuracy

Much has been discussed about the measurement (in)accuracy of the BME280 (`google bme280 temperature acccuracy`). One conclusion is that it has to do with the low-level sampling rate of the BME280 and in what conditions. Another suspicion is that it could be a yield issue with the component and a "reconditioning" is required (i.e. reheat and hydrate). 

The observation during the development of this project is that measurement accuracy is negatively impacted by self-heating of the BME280 (`google bme280 self heating`). Heat radiating from the Wemos D1 Mini can influence the measurement accuracy of temperature and humidity. 

Testing showed that placing the ESP8266 into deep sleep between sensor measurements helped to prevent false readings. Although this project implements a 10 minute deep sleep, it was observed that a deep sleep as short as [1 minute](https://www.reddit.com/r/esp8266/comments/am705f/first_iot_project_esp8266_or_should_i_use/efkqpp4/) helped to mitigate inaccurate measurement.

## Practical Deployment Example

```mermaid
graph LR;
   subgraph sensor-1
   A[bme280-shield]===B[wemos-d1-mini];
   end
   subgraph sensor-2
   F[bme280-shield]===G[wemos-d1-mini];
   end
   subgraph sensor-N
   H[bme280-shield]===I[wemos-d1-mini];
   end
   subgraph raspberry-pi-3b
   C(mosquitto)-->D(homebridge);
   style C stroke:#000,stroke-width:2px,stroke-dasharray: 5,5;
   style D stroke:#000,stroke-width:2px,stroke-dasharray: 5,5;
   end
   subgraph apple-tv-4k
   E(homekit)
   style E stroke:#000,stroke-width:2px,stroke-dasharray: 5,5;
   end
   B.->C
   G.->C
   I.->C
   D.->E


```
